#exit when any command fails
set -e
echo "Going into the java active firmware directory"
cd /home/pi/firmware/java/active
echo "Moving all jar files in the active fw directory to previous directory"
find . -name "*.jar" -exec mv {} ../previous \;
echo "going into the previous directory"
cd ../previous
echo "Removing all but the newest 5 files"
ls -A1t | tail -n +6 | xargs -r rm
echo "Going back to the firmware directory"
cd ../../
echo "Moving the newest .jar file into java/active"
find . -maxdepth 1 -name "*.jar" -exec mv {} java/active \;
echo "Going into the active library folder"
cd lib/active
echo "Moving the current .so file into the previous folder"
find . -name "*.so" -exec mv {} ../previous \;
cd ../previous
echo "Going into previous library folder and delete all but the newest 5 files"
ls -A1t | tail -n +6 | xargs -r rm
echo "Going back into the firmware directory" 
cd ../../
echo "Moving the file to the active directory"
find . -maxdepth 1 -name "*.so" -exec mv {} lib/active \;
echo "Replacing the web files"
cp -fR web/* /home/pi/web
echo "Replacing config.txt"
cp -f config.txt /boot/config.txt
echo "Replacing run before shutdown script"
cp -f preshutdown.sh /home/pi/preshutdown.sh
echo "Making preshutdown executable"
chmod 777 /home/pi/preshutdown.sh
echo "Copying preshutdown systemd unit"
sudo cp -f run-before-shutdown.service /etc/systemd/system/
echo "Reloading Daemon"
sudo systemctl daemon-reload
echo "Enabling run-before-shutdown service"
sudo systemctl enable run-before-shutdown.service
echo "removing web files"
rm -r /home/pi/firmware/web/

return
