
var tableData;
var AlarmFilter = true;
var ParamChangeFilter = true;
var ChangeoverFilter = true;
var InfoFilter = true;
var clicked = true;
var cycleKit;
var socket;
var dbwebSocket;

var DryersFilter = new Array(9).fill(true);

function convertToCSV(objArray) {
    var array = typeof objArray != 'object' ? JSON.parse(objArray) : objArray;
    var str = '';

    for (var i = 0; i < array.length; i++) {
        var line = '';
        for (var index in array[i]) {
            if (line != '') line += ','

            line += array[i][index];
        }

        str += line + '\r\n';
    }

    return str;
}

function exportCSVFile(headers, items, fileTitle) {
    if (headers) {
        items.unshift(headers);
    }

    // Convert Object to JSON
    var jsonObject = JSON.stringify(items);

    var csv = this.convertToCSV(jsonObject);

    var exportedFilenmae = fileTitle + '.csv' || 'export.csv';

    var blob = new Blob([csv], { type: 'text/csv;charset=utf-8;' });
    if (navigator.msSaveBlob) { // IE 10+
        navigator.msSaveBlob(blob, exportedFilenmae);
    } else {
        var link = document.createElement("a");
        if (link.download !== undefined) { // feature detection
            // Browsers that support HTML5 download attribute
            var url = URL.createObjectURL(blob);
            link.setAttribute("href", url);
            link.setAttribute("download", exportedFilenmae);
            link.style.visibility = 'hidden';
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }
    }
}

function download(){
  var headers = {
      eventtype: 'Event Type'.replace(/,/g, ''), // remove commas to avoid errors
      description: "Description",
	  tankpressure: "Tank Pressure (PSI)",
	  outletpressure: "Outlet Pressure (PSI)",
	  flow: "Flow (SCFD)",
	  systemonehumidity: "S1 Humidity (%)",
	  systemtwohumidity: "S2 Humidity (%)",
	  systemonedutycycle: "S1 Duty Cycle (%)",
	  systemtwodutycycle: "S2 Duty Cycle (%)",
	  systemonelastruntime: "S1 Last Runtime (MIN)",
	  systemtwolastruntime: "S2 Last Runtime (MIN)",
	  compressortemp: "Compressor Temp (Deg F)",
	  cabinettemp: "Cabinet Temp (Deg F)",
      timestamp: "Timestamp"
  };

  itemsNotFormatted = tableData;
  var itemsFormatted = [];
  var fileTitle
  itemsNotFormatted.reverse();
  // format the data
  itemsNotFormatted.forEach((item) => {
	var date = new Date(+item.timestamp)
	
	date.setMinutes(date.getMinutes() + date.getTimezoneOffset())
	if(item.eventtype == "Alarm")
	{
      itemsFormatted.push({
          eventtype: item.eventtype.replace(/,/g, ''), // remove commas to avoid errors,
          description: item.description,
          tankpressure: item.tankpressure.toFixed(1),
		  outletpressure: item.outletpressure.toFixed(1),
		  flow: item.flow.toFixed(0),
		  systemonehumidity: item.systemonehumidity.toFixed(1),
		  systemtwohumidity: item.systemtwohumidity.toFixed(1),
		  systemonedutycycle: item.systemonedutycycle.toFixed(0),
		  systemtwodutycycle: item.systemtwodutycycle.toFixed(0),
		  systemonelastruntime: item.systemonelastruntime,
		  systemtwolastruntime: item.systemtwolastruntime,
		  compressortemp: item.compressortemp.toFixed(0),
		  cabinettemp: item.cabinettemp.toFixed(0),
		  timestamp: date.toLocaleString()
		  
      });
	}
	else
	{
		itemsFormatted.push({
          eventtype: item.eventtype.replace(/,/g, ''), // remove commas to avoid errors,
          description: item.description,
          tankpressure: "n/a",
		  outletpressure: "n/a",
		  flow: "n/a",
		  systemonehumidity: "n/a",
		  systemtwohumidity: "n/a",
		  systemonedutycycle: "n/a",
		  systemtwodutycycle: "n/a",
		  systemonelastruntime: "n/a",
		  systemtwolastruntime: "n/a",
		  compressortemp: "n/a",
		  cabinettemp: "n/a",
		  timestamp: date.toLocaleString()
		  
      });
	}



  });


  fileTitle = new Date().toLocaleString() + "_Log"
  exportCSVFile(headers, itemsFormatted, fileTitle); // call the exportCSVFile() function to process the JSON and trigger the download
}

function filterMenuClick() {
	document.getElementById("myDropdown").classList.toggle("show");
}

function filterMenuClick2() {
	document.getElementById("myDropdown2").classList.toggle("show");
}

function setDryerFilter(dryer)
{
	console.log(" set Dryer ");	
	console.log(DryersFilter);	
	if(document.getElementById("dryer-"+dryer).checked)
	{
		DryersFilter[dryer] = true;
	}
	else
	{
		DryersFilter[dryer] = false;
	}
	console.log(" Number ");	
	console.log(dryer);
	console.log("  set Dryer end ");
	console.log(DryersFilter);	
	requestUpdate();
}

function alarmFilterClick()
{
	if(document.getElementById("alarmFilterButton").checked)
	{
		AlarmFilter = true;
	}
	else
	{
		AlarmFilter = false;
	}
	requestUpdate();
}
function paramFilterClick()
{
	if(document.getElementById("paramFilterButton").checked)
	{
		ParamChangeFilter = true;
	}
	else
	{
		ParamChangeFilter = false;
	}
	requestUpdate();
}
function changeoverFilterClick()
{
	if(document.getElementById("paramFilterButton").checked)
	{
		ChangeoverFilter = true;
	}
	else
	{
		ChangeoverFilter = false;
	}
	requestUpdate();
}
function infoFilterClick()
{
	if(document.getElementById("infoFilterButton").checked)
	{
		InfoFilter = true;
	}
	else
	{
		InfoFilter = false;
	}
	requestUpdate();
}
//Close the dropdown menu if the user clicks outside of it
window.onclick = function(event) {
	if (!event.target.matches('.dropbtn')) {
		var dropdowns = document.getElementsByClassName("dropdown-content");
		var i;
		for (i = 0; i < dropdowns.length; i++) {
			var openDropdown = dropdowns[i];
			if (openDropdown.classList.contains('show')) {
				openDropdown.classList.remove('show');
			}
		}
	}
}

//this function appends the json data to the table 'gable'
function appendJSON(data){

	var table = document.getElementById('tableBody');
	while(table.hasChildNodes()) {
		table.removeChild(table.childNodes[0]);  
	}
 
	var newTbody  = document.createElement('tbody');
	newTbody.id = "newTbody"
	newTbody.className = "tbstyle"
	var newThead = document.createElement('thead');
	newThead.className = "bg-extra-dark";
	newThead.innerHTML = 
		`<tr class="table100-head" style = "display:block;">
			<th class="column1">Dryer</th>
			<th class="column2">Event Type</th>
			<th class="column3">Message</th>
			<th class="column4">Timestamp</th>
		</tr>`;
	table.appendChild(newThead);
	console.log(table.innerHTML);
	data.forEach(function(object) {
		var date = new Date(+object.timestamp)
		date.setMinutes(date.getMinutes() + date.getTimezoneOffset())
		var tr = document.createElement('tr');
		tr.className = "tableRowStyle"
		
		if(object.eventtype == "Alarm")
		{ 
			tr.innerHTML =
			   `<td class = "dryerNumberData aa-bg-alert">`+object.dryer+`</td>
				<td class = "eventTypeData aa-bg-alert">`+object.eventtype+`</td>
				<td class = "descriptionData aa-bg-alert">`+object.description+`</td>
				<td class = "timestampData aa-bg-alert">`+date.toLocaleString()+`</td>`;
			newTbody.appendChild(tr);
		}
		else if (object.eventtype == "Cycle Setup Change")
		{
			tr.innerHTML =
			   `<td class = "dryerNumberData aa-bg-warning">`+object.dryer+`</td>
				<td class = "eventTypeData aa-bg-warning">`+object.eventtype+`</td>
				<td class = "descriptionData aa-bg-warning">`+object.description+`</td>
				<td class = "timestampData aa-bg-warning">`+date.toLocaleString()+`</td>`;
			newTbody.appendChild(tr);
		}
		else if (object.eventtype == "System Setting Change")
		{
			tr.innerHTML =
			   `<td class = "dryerNumberData aa-bg-warning">`+object.dryer+`</td>
				<td class = "eventTypeData aa-bg-warning">`+object.eventtype+`</td>
				<td class = "descriptionData aa-bg-warning">`+object.description+`</td>
				<td class = "timestampData aa-bg-warning">`+date.toLocaleString()+`</td>`;
			newTbody.appendChild(tr);
		}
		else if (object.eventtype == "Dryer Changeover")
		{
			tr.innerHTML =
			   `<td class = "dryerNumberData aa-bg-success">`+object.dryer+`</td>
				<td class = "eventTypeData aa-bg-success">`+object.eventtype+`</td>
				<td class = "descriptionData aa-bg-success">`+object.description+`</td>
				<td class = "timestampData aa-bg-success">`+date.toLocaleString()+`</td>`;
			newTbody.appendChild(tr);
		}
		else if (object.eventtype == "Dryer Status Change")
		{
			tr.innerHTML =
			   `<td class = "dryerNumberData aa-bg-warning">`+object.dryer+`</td>
				<td class = "eventTypeData aa-bg-warning">`+object.eventtype+`</td>
				<td class = "descriptionData aa-bg-warning">`+object.description+`</td>
				<td class = "timestampData aa-bg-warning">`+date.toLocaleString()+`</td>`;
			newTbody.appendChild(tr);
		}
		else if(object.eventtype == "Info")
		{
			tr.innerHTML =
			   `<td class = "dryerNumberData aa-bg-info">`+object.dryer+`</td>
				<td class = "eventTypeData aa-bg-info">`+object.eventtype+`</td>
				<td class = "descriptionData aa-bg-info">`+object.description+`</td>
				<td class = "timestampData aa-bg-info">`+date.toLocaleString()+`</td>`;
			newTbody.appendChild(tr);
		
		}
		else
		{
			console.log("NO DATA")
		}
	});

	if(table != null)
	{
		console.log("REPLACE")
		table.appendChild(newTbody);
		$('tbody').each(function(){
			var list = $(this).children('tr');
			$(this).html(list.get().reverse())
		});
		console.log(table.childNodes[0]);
		console.log(table.childNodes[1]);

		console.log(table.childNodes[0]);
		console.log(table.childNodes[1]);


	}
}

function requestUpdate()
{
	var dbFilter = new Array();

	dbFilter.push("events");	
	if(AlarmFilter)
	{
		dbFilter.push("Alarm");
	}
	if(ParamChangeFilter)
	{
		dbFilter.push("Cycle Setup Change");
		dbFilter.push("System Setting Change");
		dbFilter.push("Dryer Status Change");
	}
	if(ChangeoverFilter)
	{
		dbFilter.push("Dryer Changeover");
	}
	if(InfoFilter)
	{
		dbFilter.push("Info");
	}
	
	dbFilter.push("dryers");
	
	if(DryersFilter[0])
	{
		dbFilter.push("SYSTEM");	
	}
	for(var i=1; i<9; i++)
	{
		if(DryersFilter[i])
		{
			dbFilter.push(i);	
		}
	}

	
	dbFilter.push("end");
	
	console.log("UPDATE EVENT TABLE");
	console.log(dbFilter);
		
	sendCommand(dbwebSocket,"UPDATE EVENT TABLE",dbFilter);
}



