/* Used as global or commom file */

var cycleKit;
var socket;
var dbwebSocket;
var tableData;
var locked = true;
var currentPage = "index";


/**
 * Open a new WebSocket connection using the given parameters
 */
function setupWebSocket(webSocket) {
	console.log(currentPage);
	try {
		webSocket.onopen = function(openEvent) {
			console.log("WebSocket OPEN: "
							+ JSON.stringify(openEvent, null, 4));

		};
		webSocket.onclose = function(closeEvent) {
			console.log("WebSocket CLOSE: "
					+ JSON.stringify(closeEvent, null, 4));
					alert("Connection to the device is now closed!. Refresh the page.");
					$('div').remove();
		};
		webSocket.onerror = function(errorEvent) {
			console.log("WebSocket ERROR: "
					+ JSON.stringify(errorEvent, null, 4));
					alert("Connection Error!. Refresh the page.");
					$('div').remove();
		};
		webSocket.onmessage = function(messageEvent) {
			var wsMsg = messageEvent.data;
			console.log("WebSocket MESSAGE: " + wsMsg);
			cycleKit = JSON.parse(wsMsg);
			
			if(cycleKit.WebStatus != null && currentPage == "index")
			{
				cycleKit = cycleKit.WebStatus;
				updateStatus();
			}
			else if (cycleKit.WebPorts != null && currentPage == "index")
			{
				cycleKit = cycleKit.WebPorts;
				updatePorts();
			}
			else if (cycleKit.WebAbout != null && currentPage == "firmware")
			{
				cycleKit = cycleKit.WebAbout;
				updateAboutPage();
			}
			else if (cycleKit.WebAbout != null && currentPage == "event")
			{
				console.log("WebSocket EVENT");
			}
			else if (cycleKit.locked != null)
			{
				updateLockedStatus();
			}
			else if (cycleKit.error != null)
			{
				alert(cycleKit.error);
			}
				
		};
		socket = webSocket;
	} catch (exception) {
		console.error(exception);
	}
}

function setupDBSocket(webSocket)
{
		console.log(currentPage);
	try {

		webSocket.onopen = function(openEvent) {
			console.log("DBSocket OPEN: " + JSON.stringify(openEvent, null, 4));
			requestUpdate();
		};
		webSocket.onclose = function (closeEvent) {
			console.log("DBSocket CLOSE: " + JSON.stringify(closeEvent, null, 4));
		};
		webSocket.onerror = function (errorEvent) {
			console.log("DBSocket ERROR: " + JSON.stringify(errorEvent, null, 4));
		};
		webSocket.onmessage = function (messageEvent) {
			var wsMsg = messageEvent.data;
			console.log("DBSocket MESSAGE: " + wsMsg);
			tableData = JSON.parse(wsMsg);
			appendJSON(tableData);
		};
		dbwebSocket = webSocket;
	} catch (exception) {
		console.error(exception);
	}
}

function updateLockedStatus()
{
	//console.log(locked);
	locked = cycleKit.locked;
	localStorage.setItem("locked",locked);

	if (!locked) {
		document.getElementById('lock-icon').src = 'images/unlock-solid.svg';

	}
	else {
		document.getElementById('lock-icon').src = 'images/lock-solid.svg';
	}
}

function lock()
{
	sendCommand(socket,"LOCK");
}

function keywordAttempt() 
{
	var kwAttempt = prompt("Enter Keyword");
	sendCommand(socket,"UNLOCK", kwAttempt);
}

function isServerUnlocked()
{
	console.log("LOCK STATUS");
	sendCommand(socket,"LOCK STATUS");
}

function isUnlocked()
{
	if(locked)
	{
		keywordAttempt();
	}
	else
	{
		lock();
	}
}

function setCurrentPage(page){
	currentPage = page;
}

function getCurrentPage(){
	return currentPage;
}

function  clearInput(id)
{
	document.getElementById(id).value = "";
	document.getElementById(id).innerHTML = "";
}

Number.prototype.pad = function(size) {
	var s = String(this);
	while (s.length < (size || 2)) {
		s = "0" + s;
	}
	return s;
}